##
##  flex.spec -- OpenPKG RPM Specification
##  Copyright (c) 2000-2003 Cable & Wireless Deutschland GmbH
##  Copyright (c) 2000-2003 The OpenPKG Project <http://www.openpkg.org/>
##  Copyright (c) 2000-2003 Ralf S. Engelschall <rse@engelschall.com>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package versions
%define       V_release        2.5.4a
%define       V_release_maj    2.5.4
%define       V_beta           2.5.31

#   package information
Name:         flex
Summary:      Fast Lexical Analyzer Generator
URL:          http://www.gnu.org/software/flex/
Vendor:       Free Software Foundation
Packager:     The OpenPKG Project
Distribution: OpenPKG [CORE]
Group:        Language
License:      BSD
Version:      %{V_release}
Release:      20030402

#   package options
%option       with_beta  yes

#   list of sources
Source0:      ftp://ftp.gnu.org/non-gnu/flex/flex-%{V_release}.tar.gz
Source1:      http://osdn.dl.sourceforge.net/sourceforge/lex/flex-%{V_beta}.tar.gz

#   build information
Prefix:       %{l_prefix}
BuildRoot:    %{l_buildroot}
BuildPreReq:  OpenPKG, openpkg >= 20030103, bison, make
PreReq:       OpenPKG, openpkg >= 20030103
AutoReq:      no
AutoReqProv:  no

%description
    Flex is a tool for generating scanners: programs which recognized lexical
    patterns in text. flex reads the given input files for a description of a
    scanner to generate. The description is in the form of pairs of regular
    expressions and C code, called rules. flex generates as output a C source
    file, lex.yy.c, which defines a routine yylex(). This file is compiled and
    linked with the -lfl library to produce an executable. When the executable
    is run, it analyzes its input for occurrences of the regular expressions.
    Whenever it finds one, it executes the corresponding C code.

%prep
    %setup0 -q -c -n flex-%{version}
%if "%{with_beta}" == "yes"
    %setup1 -q -T -D -a 1
%endif

%build
    ( cd flex-%{V_release_maj}
      CC="%{l_cc}" \
      CFLAGS="%{l_cflags -O}" \
      ./configure \
          --prefix=$RPM_BUILD_ROOT%{l_prefix}
      %{l_make} %{l_mflags}
    )
%if "%{with_beta}" == "yes"
    ( cd flex-%{V_beta}
      CC="%{l_cc}" \
      CFLAGS="%{l_cflags -O}" \
      ./configure \
          --prefix=%{l_prefix} \
          --disable-nls
      %{l_make} %{l_mflags}
    )
%endif

%install
    rm -rf $RPM_BUILD_ROOT
%if "%{with_beta}" == "yes"
    ( cd flex-%{V_beta}
      %{l_make} %{l_mflags} install AM_MAKEFLAGS="DESTDIR=$RPM_BUILD_ROOT"
      mv $RPM_BUILD_ROOT%{l_prefix}/bin/flex \
         $RPM_BUILD_ROOT%{l_prefix}/bin/flex-beta
      mv $RPM_BUILD_ROOT%{l_prefix}/include/FlexLexer.h \
         $RPM_BUILD_ROOT%{l_prefix}/include/FlexLexer-beta.h
      mv $RPM_BUILD_ROOT%{l_prefix}/lib/libfl.a \
         $RPM_BUILD_ROOT%{l_prefix}/lib/libfl-beta.a
      mv $RPM_BUILD_ROOT%{l_prefix}/man/man1/flex.1 \
         $RPM_BUILD_ROOT%{l_prefix}/man/man1/flex-beta.1
    )
%endif
    ( cd flex-%{V_release_maj}
      %{l_make} %{l_mflags} install
      rm -f $RPM_BUILD_ROOT%{l_prefix}/bin/flex++
    )
    rm -f $RPM_BUILD_ROOT%{l_prefix}/info/dir
    strip $RPM_BUILD_ROOT%{l_prefix}/bin/* >/dev/null 2>&1 || true
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean
    rm -rf $RPM_BUILD_ROOT

